/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import { Contract, ContractTransaction, EventFilter } from "ethers";
import { Provider } from "ethers/providers";
import { BigNumber } from "ethers/utils";
import { TransactionOverrides } from ".";

export class Gateway extends Contract {
  functions: {
    getERC20(contractAddress: string): Promise<BigNumber>;

    nonces(arg0: string): Promise<BigNumber>;

    getERC721(
      uid: number | string | BigNumber,
      contractAddress: string
    ): Promise<boolean>;

    getERC721X(
      tokenId: number | string | BigNumber,
      contractAddress: string
    ): Promise<BigNumber>;

    depositERC20(
      amount: number | string | BigNumber,
      contractAddress: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    withdrawERC20(
      amount: number | string | BigNumber,
      contractAddress: string,
      _valIndexes: (number | string | BigNumber)[],
      _v: (number | string | BigNumber)[],
      _r: (string)[],
      _s: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    withdrawERC721X(
      tokenId: number | string | BigNumber,
      amount: number | string | BigNumber,
      contractAddress: string,
      _valIndexes: (number | string | BigNumber)[],
      _v: (number | string | BigNumber)[],
      _r: (string)[],
      _s: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    withdrawERC721(
      uid: number | string | BigNumber,
      contractAddress: string,
      _valIndexes: (number | string | BigNumber)[],
      _v: (number | string | BigNumber)[],
      _r: (string)[],
      _s: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    withdrawETH(
      amount: number | string | BigNumber,
      _valIndexes: (number | string | BigNumber)[],
      _v: (number | string | BigNumber)[],
      _r: (string)[],
      _s: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    onERC721XReceived(
      _operator: string,
      _from: string,
      _tokenId: number | string | BigNumber,
      _amount: number | string | BigNumber,
      _data: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    onERC721XBatchReceived(
      _operator: string,
      _from: string,
      _types: (number | string | BigNumber)[],
      _amounts: (number | string | BigNumber)[],
      _data: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    onERC721Received(
      _operator: string,
      _from: string,
      _uid: number | string | BigNumber,
      _data: (string)[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    loomAddress(): Promise<string>;
    getETH(): Promise<BigNumber>;
  };
  filters: {
    ETHReceived(from: null, amount: null): EventFilter;

    ERC721Received(
      operator: null,
      from: null,
      tokenId: null,
      contractAddress: null,
      data: null
    ): EventFilter;

    ERC721XReceived(
      operator: null,
      from: null,
      tokenId: null,
      amount: null,
      contractAddress: null,
      data: null
    ): EventFilter;

    ERC721XBatchReceived(
      operator: null,
      to: null,
      tokenTypes: null,
      amounts: null,
      contractAddress: null,
      data: null
    ): EventFilter;

    ERC20Received(from: null, amount: null, contractAddress: null): EventFilter;

    TokenWithdrawn(
      owner: string | null,
      kind: null,
      contractAddress: null,
      value: null
    ): EventFilter;

    LoomCoinReceived(
      from: string | null,
      amount: null,
      loomCoinAddress: null
    ): EventFilter;
  };
}
